import { ConnectionPoolAdapter } from './base/connectionPool';
import { ConnectionAdapter } from './base/connection';
import { Query, Data } from '../../../query/domain';
import { ConnectionConfig } from '../../domain';
import { Connection } from '../../application';
import { MappingConfigService } from '../../../schema/application';
import { DialectService } from '../../../language/application';
import { Helper } from '../../../shared/application';
export declare class MongoDBConnectionPoolAdapter extends ConnectionPoolAdapter {
    private static lib;
    constructor(config: ConnectionConfig, helper: Helper);
    init(): Promise<void>;
    acquire(): Promise<Connection>;
    release(connection: Connection): Promise<void>;
    end(): Promise<void>;
}
export declare class MongodbConnectionAdapter extends ConnectionAdapter {
    private session?;
    select(mapping: MappingConfigService, dialect: DialectService, query: Query, data: Data): Promise<any>;
    insert(mapping: MappingConfigService, dialect: DialectService, query: Query, data: Data): Promise<any>;
    bulkInsert(mapping: MappingConfigService, dialect: DialectService, query: Query, array: any[]): Promise<any[]>;
    private getInsertList;
    private getInsertListIncludes;
    private getInsertListInclude;
    update(mapping: MappingConfigService, dialect: DialectService, query: Query, data: Data): Promise<number>;
    bulkUpdate(_mapping: MappingConfigService, _dialect: DialectService, _query: Query, _array: any[]): Promise<number>;
    private getObject;
    delete(mapping: MappingConfigService, dialect: DialectService, query: Query, data: Data): Promise<number>;
    execute(_query: Query): Promise<any>;
    executeSentence(_sentence: any): Promise<any>;
    executeDDL(_query: Query): Promise<any>;
    beginTransaction(): Promise<void>;
    commit(): Promise<void>;
    rollback(): Promise<void>;
    private arrayToList;
    private parseTemplate;
    private getValue;
    private getNextSequenceValue;
    truncateEntity(mapping: MappingConfigService, query: Query): Promise<any>;
    createEntity(mapping: MappingConfigService, query: Query): Promise<any>;
    createSequence(_mapping: MappingConfigService, query: Query): Promise<any>;
    createIndex(mapping: MappingConfigService, query: Query): Promise<any>;
    addPk(mapping: MappingConfigService, query: Query): Promise<any>;
    addUk(mapping: MappingConfigService, query: Query): Promise<any>;
    dropSequence(_mapping: MappingConfigService, query: Query): Promise<any>;
    dropEntity(mapping: MappingConfigService, query: Query): Promise<any>;
    dropPk(mapping: MappingConfigService, query: Query): Promise<any>;
    dropUk(mapping: MappingConfigService, query: Query): Promise<any>;
    dropIndex(mapping: MappingConfigService, query: Query): Promise<any>;
}
