import { Property, Relation, Behavior, Constraint } from '../../schema/domain/schema';
import { SentenceAction } from '../../schema/domain/actions';
import { Parameter } from '3xpr';
export interface QueryArgs {
    action: SentenceAction;
    dialect: string;
    source: string;
    sentence: string;
    entity: string;
    columns?: Property[];
    parameters?: Parameter[];
    constraints?: Constraint[];
    values?: Behavior[];
    defaults?: Behavior[];
    includes?: Include[];
    expression?: string;
}
export declare class Query {
    action: SentenceAction;
    includes: Include[];
    sentence: string;
    dialect: string;
    source: string;
    entity: string;
    columns: Property[];
    parameters: Parameter[];
    constraints: Constraint[];
    values: Behavior[];
    defaults: Behavior[];
    expression: string;
    constructor(args: QueryArgs);
}
export declare class Include {
    name: string;
    query: Query;
    relation: Relation;
    constructor(name: string, query: Query, relation: Relation);
}
export interface ExecuteResult {
    result?: any;
    error?: Error;
}
export interface QueryOptions {
    view?: string;
    stage?: string;
    chunkSize?: number;
    tryAllCan?: boolean;
    headers?: any;
}
export interface QueryPlan {
    entity: string;
    dialect: string;
    source: string;
    sentence: string;
    children?: QueryPlan[];
}
