import { Operand } from '3xpr';
import { EntityMapping } from '../../../../schema/domain';
import { Query } from '../../../../query/domain';
import { Field, Sentence, Join, Map, Filter, GroupBy, Insert } from '../../../domain';
import { DmlBuilderAdapter } from '../base/dmlBuilder';
export declare class NoSqlDMLBuilderAdapter extends DmlBuilderAdapter {
    build(sentence: Sentence): Query;
    protected buildSelectSentence(sentence: Sentence): string;
    private addAggregate;
    protected buildReplaceRoot(entity: EntityMapping): string;
    protected buildDeleteSentence(sentence: Sentence): string;
    protected getGroupBy(map: Map, _groupBy: GroupBy, sentence: Sentence): any;
    protected getMap(map: Map, sentence: Sentence): any;
    protected getComposite(sentence: Sentence): string | undefined;
    protected getChildrenMap(sentence: Sentence): any;
    protected buildJoins(entity: EntityMapping, joins: Join[]): string;
    protected buildFilter(operand: Filter): string;
    protected getFieldMapping(operand: Field, alias?: string): string;
    protected buildInsert(operand: Insert, entity: EntityMapping): string;
    protected buildUpdateSentence(sentence: Sentence): string;
    protected buildUpdate(sentence: Sentence): string;
    protected buildField(operand: Field): string;
    protected buildObject(operand: Operand): string;
    protected setPrefixToField(operand: Operand, prefix: string): void;
    protected hadGroupFunction(operand: Operand): boolean;
}
